Index: LineClipper.java
===================================================================
--- LineClipper.java	(revision 720)
+++ LineClipper.java	(working copy)
@@ -56,32 +56,60 @@
 		if (!foundOutside)
 			return null;
 
-		List<List<Coord>> ret = new ArrayList<List<Coord>>();
-		List<Coord> nlist = new ArrayList<Coord>();
-		ret.add(nlist);
+		class Segment {
+			boolean inside;
+			Coord end;
+			Segment(boolean inside, Coord end) {
+				this.inside = inside;
+				this.end = end;
+			}
+		}
 
+		List<Segment> segs = new ArrayList<Segment>();
 		Iterator<Coord> it = coords.iterator();
-		Coord last = it.next();
+		Coord first = it.next();
+		Coord co = first;
 		while (it.hasNext()) {
-			Coord co = it.next();
+			Coord last = co;
+			co = it.next();
 			Coord[] ends = {last, co};
 			ends = clip(a, ends);
 			if (ends == null) {
-				last = co;
+				segs.add(new Segment(false, co));
 				continue;
 			}
-			if (last.equals(ends[0])) {
-				if (nlist.isEmpty())
-					nlist.add(last);
-			} else {
-				// Need to start a new one
-				nlist = new ArrayList<Coord>();
-				ret.add(nlist);
-				nlist.add(ends[0]);
+			if (!last.equals(ends[0]))
+				segs.add(new Segment(false, ends[0]));
+			segs.add(new Segment(true, ends[1]));
+			if (!co.equals(ends[1]))
+				segs.add(new Segment(false, co));
+		}
+
+		List<List<Coord>> ret = new ArrayList<List<Coord>>();
+
+		Iterator<Segment> itseg = segs.iterator();
+		while (itseg.hasNext()) {
+			Segment seg = itseg.next();
+
+			// skip over outside segments
+			while (!seg.inside && itseg.hasNext()) {
+				first = seg.end;
+				seg = itseg.next();
 			}
-			nlist.add(ends[1]);
-			last = co;
+			if (!seg.inside)
+				break; // no inside segment found
+
+			List<Coord> nlist = new ArrayList<Coord>();
+			nlist.add(first);
+			while (seg.inside) {
+				nlist.add(seg.end);
+				if (!itseg.hasNext())
+					break;
+				seg = itseg.next();
+			}
+			ret.add(nlist);
 		}
+
 		return ret;  
 	}
 
